package de.intevation.flys.client.server;

import java.io.InputStream;
import java.io.IOException;

import org.w3c.dom.Document;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import de.intevation.artifacts.common.utils.ClientProtocolUtils;
import de.intevation.artifacts.common.utils.XMLUtils;

import de.intevation.artifacts.httpclient.http.HttpClient;
import de.intevation.artifacts.httpclient.http.HttpClientImpl;
import de.intevation.artifacts.httpclient.exceptions.ConnectionException;

import de.intevation.flys.client.shared.exceptions.ServerException;
import de.intevation.flys.client.shared.model.Collection;

import de.intevation.flys.client.client.services.MapOutputService;


public class MapOutputServiceImpl
extends      RemoteServiceServlet
implements   MapOutputService
{

    public void doOut(Collection collection, String serverUrl)
    throws ServerException
    {
        System.out.println("MapOutputServiceImpl.doGet");

        String uuid = collection.identifier();

        try {
            Document request = ClientProtocolUtils.newOutCollectionDocument(
                uuid, "floodmap", "floodmap");

            HttpClient client = new HttpClientImpl(serverUrl);
            InputStream    is = client.collectionOut(request, uuid, "floodmap");

            Document response = XMLUtils.parseDocument(is);

            // TODO parse response document and return a MapConfig object
        }
        catch (ConnectionException e) {
            e.printStackTrace();
            System.err.println(e.getMessage());
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
            System.err.println(ioe.getMessage());
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
